#include "MonochromeLib.h"
#include "fxlib.h"
#include "EasyInput.h"
#include "stdio.h"
//Ajout de syscall.h/.src et de EasyInput.c
//Enlever le "Enigme()" de LAYTON.c !!!
//Dans les enigmes : F1 X pour les choix, F6 pour revoir l'nonc, Shift pour valider, Exit pour quitter
int Enigme();
int ReponseFausse();
int BonneReponse();
int Debloquage();
int Clear();
int EasyInputError;
int FinEnigme();
extern int Layton[];
extern char Enigmes[];
int Mots[10];
const unsigned char professeurLayton[]={
		0x0, 0x0, 0x0, 0x3, 
		0x0, 0x1f, 0xe0, 0x3, 
		0x0, 0xff, 0xfc, 0x3, 
		0x1, 0xe0, 0x1e, 0x3, 
		0x7, 0x8f, 0xc7, 0x83, 
		0xf, 0x7f, 0xf9, 0xc3, 
		0xc, 0xff, 0xfe, 0xc3, 
		0x1c, 0x78, 0xfe, 0x63, 
		0x38, 0x77, 0xfe, 0x73, 
		0x30, 0x77, 0xfe, 0x33, 
		0x70, 0x77, 0xfe, 0x3b, 
		0x60, 0x77, 0xfc, 0x1b, 
		0x60, 0x73, 0xfc, 0x1b, 
		0x60, 0x73, 0xfc, 0x1b, 
		0x60, 0x72, 0x1c, 0x1b, 
		0x60, 0x72, 0xec, 0x1b, 
		0x60, 0x77, 0x6c, 0x1b, 
		0x60, 0x61, 0xfc, 0x1b, 
		0x60, 0x66, 0x1c, 0x1b, 
		0x70, 0x7f, 0xe0, 0x3b, 
		0x37, 0xff, 0x9f, 0x33, 
		0x3f, 0xff, 0x7f, 0xf3, 
		0x1b, 0xfc, 0xff, 0xe3, 
		0x1e, 0xe3, 0x7, 0xe3, 
		0xf, 0xfc, 0x7, 0xc3, 
		0x7, 0x80, 0xf, 0x83, 
		0x3, 0xc0, 0x3f, 0x3, 
		0x0, 0xff, 0xfc, 0x3, 
		0x0, 0x3f, 0xf0, 0x3, 
		0x0, 0x0, 0x0, 0x3, 
		};
int Enigme(int enigme)
	{
	int x=0;
	char eni[50];
	char * touche1="No_touch";
	char buffer[200];
	int largeur=1;
	int longueur=1;
	while(x<57)
		{
		Clear();
		EcranNoir();
		ML_bmp_xor ( professeurLayton,x,7,30,30);
		ML_display_vram();
		Sleep(20);
		x++;
		}
	Sleep(350);
	while(x>47)
		{
		Clear();
		EcranNoir();
		ML_bmp_xor ( professeurLayton,x,7,30,30);
		ML_display_vram();
		Sleep(40);
		x--;
		}
	PrintXY(35,45,(const unsigned char*)" Enigme ",1);
	sprintf(eni,"%d",enigme);
	PrintXY(80,45,(unsigned char *)eni,1);
	ML_display_vram();
	NoShift();
	Shift();
	ML_clear_vram();
	if (enigme==1)
		{
		ML_clear_vram();
		PrintMini(2,5,(const unsigned char*)"Sur un arbre a 2 branches, des",1);
		PrintMini(2,12,(const unsigned char*)"oiseaux se parlent. L'un d'en",1);
		PrintMini(2,19,(const unsigned char*)"haut dit a ceux d'en bas : \"si",1);
		PrintMini(2,26,(const unsigned char*)"un de vous nous rejoint, nous",1);
		PrintMini(2,33,(const unsigned char*)"serons alors 2 fois plus que",1);
		PrintMini(2,40,(const unsigned char*)"vous, par contre si un de nous",1);
		PrintMini(2,47,(const unsigned char*)"descend, nous serons alors",1);
		PrintMini(2,54,(const unsigned char*)"a egalite.\" Combien sont-ils ?",1);
		ML_display_vram();
		NoShift();
		Shift();
		ML_clear_vram();
		PrintMini(2,5,(const unsigned char*)"\"Si un de vous nous rejoint, ",1);
		PrintMini(2,12,(const unsigned char*)"nous serons alors 2 fois plus",1);
		PrintMini(2,19,(const unsigned char*)"que vous, par contre si un de",1);
		PrintMini(2,26,(const unsigned char*)"nous descend, nous serons al-",1);
		PrintMini(2,33,(const unsigned char*)"ors a egalite.\"",1);
		ML_rectangle(5,45,122,57,1,1,0);
		NoShift();
		EasyInputError=EI_input_string(buffer, 199,ALLOW_09,2,7, 35, LEFT, NORMAL);
		if (!EasyInputError)
			{
			return;
			}
		ML_clear_vram();
		if(!strcmp(buffer,"12")) 
			{
			BonneReponse();
			FinEnigme(eni,20);
			PrintMini(3,20,(const unsigned char*)"Ils sont bien 7 en haut et 5",1);
			PrintMini(3,27,(const unsigned char*)"en bas, mais comment se",1);
			PrintMini(3,34,(const unsigned char*)"parlent-ils ?",1);
			ML_display_vram();
			if (!Enigmes[1])
				{
				Enigmes[1]=1;
				Layton[3]++;
				Layton[4]+=20;
				NoShift();
				Shift();
				Debloquage(enigme);
				}
			}
		else
			{
			MauvaiseReponse();
			return;
			}
		ML_display_vram();
		}
	if (enigme==2)
		{
		ML_clear_vram();
		PrintMini(6,3,(const unsigned char*)"Un coq pond un oeuf sur la ",1);
		PrintMini(2,10,(const unsigned char*)"pointe du toit d'une maison. De",1);
		PrintMini(2,17,(const unsigned char*)"quel cote va-t-il tomber, sac-",1);
		PrintMini(2,24,(const unsigned char*)"hant qu'il pese 16 kilos ?",1);
		PrintMini(2,31,(const unsigned char*)"Ecrivez la reponse en majus-",1);
		PrintMini(2,38,(const unsigned char*)"cules.",1);
		ML_rectangle(5,45,122,57,1,1,0);
		ML_display_vram();
		NoShift();
		EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, ALPHA_LOCKED);
		if (!EasyInputError)
			{
			return;
			}
		if(!strcmp(buffer,"MILIEU")||!strcmp(buffer,"AUCUN")||!strcmp(buffer,"TOIT")||!strcmp(buffer,"NON")||!strcmp(buffer,"IMPOSSIBLE")||!strcmp(buffer,"CENTRE")||!strcmp(buffer,"0")) 
			{
			BonneReponse();
			FinEnigme(eni,20);
			PrintMini(3,20,(const unsigned char*)"Un coq ne pond pas !",1);
			ML_display_vram();
			if (!Enigmes[2])
				{
				Enigmes[2]=1;
				Layton[3]++;
				Layton[4]+=30;
				NoShift();
				Shift();
				Debloquage(enigme);
				}
			}
		else
			{
			MauvaiseReponse();
			return;
			}
		ML_display_vram();
		}
	if (enigme==3)
		{
		Enigme3:
		ML_clear_vram();
		PrintMini(5,5,(const unsigned char*)"Une personne a mange les",1);
		PrintMini(5,12,(const unsigned char*)"gateaux du boulanger ! Voici ce",1);
		PrintMini(5,19,(const unsigned char*)"que les 4 suspects disent pour",1);
		PrintMini(5,26,(const unsigned char*)"leur defense :",1);
		PrintMini(5,33,(const unsigned char*)"A : C'est B le coupable !",1);
		PrintMini(5,40,(const unsigned char*)"B : D les a tous manges !",1);
		PrintMini(5,47,(const unsigned char*)"C : Ce n'est pas moi !",1);
		PrintMini(5,54,(const unsigned char*)"D : B est un sale menteur !",1);
		ML_display_vram();
		if (IsKeyDown(KEY_CTRL_SHIFT))
				{
				NoShift();
				}
		Shift();
		ML_clear_vram();
		PrintMini(5,5,(const unsigned char*)"Seule un dit la verite, qui a",1);
		PrintMini(5,12,(const unsigned char*)"mange les gateaux ?",1);
		PrintMini(5,33,(const unsigned char*)"A : C'est B le coupable !",1);
		PrintMini(5,40,(const unsigned char*)"B : D les a tous manges !",1);
		PrintMini(5,47,(const unsigned char*)"C : Ce n'est pas moi !",1);
		PrintMini(5,54,(const unsigned char*)"D : B est un sale menteur !",1);
		ML_display_vram();
		NoShift();
		Shift();
		ML_clear_vram();
		PrintMini(82,10,(const unsigned char*)"Repondre :",1);
		PrintMini(82,17,(const unsigned char*)"F1-F4",1);
		PrintMini(82,26,(const unsigned char*)"Enonce : F6",1);
		PrintMini(82,35,(const unsigned char*)"Quitter :",1);
		PrintMini(82,42,(const unsigned char*)"Exit",1);
		Enigme3();
		touche1="No_touch";
		while (touche1=="No_touch")
			{
			if(IsKeyDown(KEY_CTRL_F6))
				{
				ML_clear_vram();
				ML_clear_screen();
				goto Enigme3;
				}
			if(IsKeyDown(KEY_CTRL_F1))
				{
				touche1="F1";
				}
			if(IsKeyDown(KEY_CTRL_F2))
				{
				touche1="F2";
				}
			if(IsKeyDown(KEY_CTRL_F3))
				{
				touche1="F3";
				}
			if(IsKeyDown(KEY_CTRL_F4))
				{
				touche1="F4";
				}
			if(IsKeyDown(KEY_CTRL_EXIT))
				{
				ML_clear_vram();
				return;
				}
			}
		if (touche1!="F3")
			{
			MauvaiseReponse();
			return;
			}
		else
			{
			BonneReponse();
			FinEnigme(eni,30);
			PrintMini(3,20,(const unsigned char*)"Bravo, il ne reste plus qu'a",1);
			PrintMini(3,27,(const unsigned char*)"courir, il est deja parti...",1);
			ML_display_vram();
			if (!Enigmes[3])
				{
				Enigmes[3]=1;
				Layton[3]++;
				Layton[4]+=30;
				NoShift();
				Shift();
				Debloquage(enigme);
				}

			}
			Fin3:
			ML_display_vram();
		}

		if (enigme==4)
			{
			ML_clear_vram();
			PrintMini(2,1,(const unsigned char*)"Le boulanger sert 4 clients, il",1);
			PrintMini(2,7,(const unsigned char*)"vend : la moitie de son stock",1);
			PrintMini(2,13,(const unsigned char*)"et une demi-baguette au 1er.",1);
			PrintMini(2,19,(const unsigned char*)"Un tiers de son stock plus un",1);
			PrintMini(2,25,(const unsigned char*)"tiers de baguette au 2eme. Un",1);
			PrintMini(2,31,(const unsigned char*)"quart de son stock et un quart",1);
			PrintMini(2,37,(const unsigned char*)"de baguette au 3eme. Un 5eme",1);
			PrintMini(2,43,(const unsigned char*)"de son stock et un 5eme de",1);
			PrintMini(2,49,(const unsigned char*)"baguette au 4eme.",1);
			ML_display_vram();
			if (IsKeyDown(KEY_CTRL_SHIFT))
				{
				NoShift();
				}
			Shift();
			ML_clear_vram();
			PrintMini(10,3,(const unsigned char*)" Il lui reste 11 baguettes.",1);
			PrintMini(3,10,(const unsigned char*)"Combien avait-il de baguettes ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_09,2,7, 35, LEFT, NORMAL);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"59")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"Il a du bien travaille ce matin",1);
				PrintMini(3,27,(const unsigned char*)" ! (dedicace a Xavier59 ;-) )",1);
				ML_display_vram();
				if (!Enigmes[4])
					{
					Enigmes[4]=1;
					Layton[3]++;
					Layton[4]+=40;
					NoShift();
					Shift();
					Debloquage(enigme);
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}

		if (enigme==5)
			{
			ML_clear_vram();
			PrintMini(5,2,(const unsigned char*)"Pour une experience, un cher-",1);
			PrintMini(5,8,(const unsigned char*)"cheur a besoin d'utiliser son",1);
			PrintMini(5,14,(const unsigned char*)"horloge. Il veut etudier les ",1);
			PrintMini(5,20,(const unsigned char*)"mouvements des aiguilles.",1);
			PrintMini(5,26,(const unsigned char*)"Sachant qu'elle est a l'heure,",1);
			PrintMini(5,32,(const unsigned char*)"combien de fois l'aiguille des",1);
			PrintMini(5,38,(const unsigned char*)"minutes depassera-t-elle celle",1);
			PrintMini(5,44,(const unsigned char*)"des heures entre midi et",1);
			PrintMini(5,50,(const unsigned char*)"minuit ?",1);
			ML_display_vram();
			if (IsKeyDown(KEY_CTRL_SHIFT))
					{
					NoShift();
					}
			Shift();
			ML_clear_vram();
			Enigme5();
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_09,2,7, 35, LEFT, NORMAL);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"10")) 
			{
			BonneReponse();
			FinEnigme(eni,30);
			PrintMini(3,20,(const unsigned char*)"L'aiguille des minutes va doub-",1);
			PrintMini(3,27,(const unsigned char*)"ler 10 fois celle des heures,",1);
			PrintMini(3,34,(const unsigned char*)"mais a quoi vont lui servir ces",1);
			PrintMini(3,40,(const unsigned char*)"calculs ?",1);
			ML_display_vram();
			if (!Enigmes[5])
				{
				Enigmes[5]=1;
				Layton[3]++;
				Layton[4]+=50;
				NoShift();
				Shift();
				Debloquage(enigme);
				}
			}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}

		if (enigme==6)
			{
			ML_clear_vram();
			PrintMini(5,3,(const unsigned char*)"Pour nourrir mes chats et mes",1);
			PrintMini(5,10,(const unsigned char*)"chiens, il me faut 56 biscuits.",1);
			PrintMini(5,17,(const unsigned char*)"Sachant que les chiens en man-",1);
			PrintMini(5,24,(const unsigned char*)"gent 6 chacun et que les chats",1);
			PrintMini(5,31,(const unsigned char*)"en mangent 5,",1);
			PrintMini(5,38,(const unsigned char*)"combien ai-je de chats ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_09,2,7, 35, LEFT,NORMAL);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"4")) 
			{
			BonneReponse();
			FinEnigme(eni,30);
			PrintMini(3,20,(const unsigned char*)"J'ai bien 4 chats :",1);
			PrintMini(3,27,(const unsigned char*)"en partant du principe qu'il n'",1);
			PrintMini(3,34,(const unsigned char*)"y a que des chiens, on en com-",1);
			PrintMini(3,41,(const unsigned char*)"pte 10 pour 60 biscuits. En",1);
			PrintMini(3,48,(const unsigned char*)"remplacant 4 chiens par des",1);
			PrintMini(3,55,(const unsigned char*)"chats, on a bien 56 biscuits !",1);
			ML_display_vram();
			if (!Enigmes[6])
				{
				Enigmes[6]=1;
				Layton[3]++;
				Layton[4]+=30;
				NoShift();
				Shift();
				Debloquage(enigme);
				}
			}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}
		if (enigme==9)
			{
			ML_clear_vram();
			PrintMini(5,3,(const unsigned char*)"Est-il possible pour un homme",1);
			PrintMini(5,10,(const unsigned char*)"de nationalite Francaise d'ep-",1);
			PrintMini(5,17,(const unsigned char*)"ouser la soeur de sa veuve ?",1);
			PrintMini(5,24,(const unsigned char*)"Repondez par OUI ou par NON.",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, ALPHA_LOCKED);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"NON")) 
				{
				BonneReponse();
				FinEnigme(eni,30);
				PrintMini(3,20,(const unsigned char*)"Si on a une veuve, c'est que",1);
				PrintMini(3,27,(const unsigned char*)"l'on est mort, on ne peut donc",1);
				PrintMini(3,34,(const unsigned char*)"epouser personne !",1);
				ML_display_vram();
				NoShift();
				if (!Enigmes[9])
					{
					Enigmes[9]=1;
					Layton[3]++;
					Layton[4]+=30;
					Debloquage(-2);
					NoShift();
					Debloquage(-1);
					NoShift();
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}

		
		if (enigme==8)
			{
			Enigme81:
			ML_clear_vram();
			PrintMini(5,3,(const unsigned char*)"Il y a 5 maisons de 5 couleurs",1);
			PrintMini(5,9,(const unsigned char*)"differentes. Dans chaque mai-",1);
			PrintMini(5,15,(const unsigned char*)"son vit une personne de natio-",1);
			PrintMini(5,21,(const unsigned char*)"nalite differente. Chacun boit",1);
			PrintMini(5,27,(const unsigned char*)"une certaine boisson, fume un",1);
			PrintMini(5,33,(const unsigned char*)"certain cigare et a un cer-",1);
			PrintMini(5,39,(const unsigned char*)"tain animal. Avec les indices",1);
			PrintMini(5,45,(const unsigned char*)"donnes ci-apres, ecrivez",1);
			PrintMini(5,51,(const unsigned char*)"la couleur de la maison de",1);
			PrintMini(5,57,(const unsigned char*)"celui qui a un poisson.",1);
			ML_display_vram();
			NoShift();
			while(IsKeyUp(KEY_CTRL_RIGHT)&&IsKeyUp(KEY_CTRL_SHIFT)){}
			Enigme82:
			ML_clear_vram();
			PrintMini(5,3,(const unsigned char*)"L'Anglais a la maison rouge.",1);
			PrintMini(5,9,(const unsigned char*)"Le Suedois a des chiens.",1);
			PrintMini(5,15,(const unsigned char*)"Le Danois boit du the.",1);
			PrintMini(5,21,(const unsigned char*)"La maison verte est a gauche",1);
			PrintMini(5,27,(const unsigned char*)"de la blanche.",1);
			PrintMini(5,33,(const unsigned char*)"Le propietaire de la maison",1);
			PrintMini(5,39,(const unsigned char*)"verte boit du cafe.",1);
			PrintMini(5,45,(const unsigned char*)"Celui qui fume des Pall Mall",1);
			PrintMini(5,51,(const unsigned char*)"a des oiseaux.",1);
			ML_display_vram();
			NoShift();
			while(IsKeyUp(KEY_CTRL_RIGHT)&&IsKeyUp(KEY_CTRL_SHIFT)&&IsKeyUp(KEY_CTRL_LEFT)){}
			if (IsKeyDown(KEY_CTRL_LEFT))
				{
				goto Enigme81;
				}
			Enigme83:
			ML_clear_vram();
			PrintMini(5,3,(const unsigned char*)"Le proprietaire de la maison",1);
			PrintMini(5,9,(const unsigned char*)"jaune fume des Dunhill.",1);
			PrintMini(5,15,(const unsigned char*)"Celui qui a la maison du centre",1);
			PrintMini(5,21,(const unsigned char*)"boit du lait.",1);
			PrintMini(5,27,(const unsigned char*)"Le Norvegien a la 1ere maison.",1);
			PrintMini(5,33,(const unsigned char*)"Celui qui fume des Blend vit a",1);
			PrintMini(5,39,(const unsigned char*)"cote de celui qui a des chats.",1);
			PrintMini(5,45,(const unsigned char*)"Celui qui a un cheval est le",1);
			PrintMini(5,51,(const unsigned char*)"voisin du fumeur de Dunhill.",1);
			ML_display_vram();
			NoShift();
			while(IsKeyUp(KEY_CTRL_RIGHT)&&IsKeyUp(KEY_CTRL_SHIFT)&&IsKeyUp(KEY_CTRL_LEFT)){}
			if (IsKeyDown(KEY_CTRL_LEFT))
				{
				goto Enigme82;
				}
			ML_clear_vram();
			PrintMini(5,3,(const unsigned char*)"Celui qui fume des Blue Master",1);
			PrintMini(5,9,(const unsigned char*)"boit de la biere.",1);
			PrintMini(5,15,(const unsigned char*)"L'Allemand fume des Prince.",1);
			PrintMini(5,21,(const unsigned char*)"Le Norvegien vit a cote de la",1);
			PrintMini(5,27,(const unsigned char*)"maison bleue.",1);
			PrintMini(5,33,(const unsigned char*)"Celui qui fume des Blend a",1);
			PrintMini(5,39,(const unsigned char*)"un voisin qui boit de l'eau.",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, ALPHA_LOCKED);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"VERT")||!strcmp(buffer,"vert")||!strcmp(buffer,"Vert")||!strcmp(buffer,"VERTE")||!strcmp(buffer,"verte")||!strcmp(buffer,"Verte")) 
				{
				BonneReponse();
				FinEnigme(eni,110);
				PrintMini(3,20,(const unsigned char*)"Cette enigme est plus connue",1);
				PrintMini(3,27,(const unsigned char*)"sous le nom d'Enigme d'Eins-",1);
				PrintMini(3,34,(const unsigned char*)"tein. Vous comprenez mieux",1);
				PrintMini(3,41,(const unsigned char*)"pourquoi elle etait dure !",1);
				ML_display_vram();
				if (!Enigmes[8])
					{
					Enigmes[8]=1;
					Layton[3]++;
					Layton[4]+110;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				Fin8:
				ML_display_vram();
			}
		if (enigme==7)
			{
			ML_clear_vram();
			if ((!Enigmes[1])&&(!Enigmes[2])&&(!Enigmes[3])&&(!Enigmes[4])&&(!Enigmes[5])&&(!Enigmes[6]))
				{
				PrintMini(5,3,(const unsigned char*)"Aucun mot debloque.",1);
				}
			if (Enigmes[1])
				{
				PrintMini(5,3,(const unsigned char*)"Carnet",1);
				}
			if (Enigmes[2])
				{
				PrintMini(5,10,(const unsigned char*)"Voix",1);
				}
			if (Enigmes[3])
				{
				PrintMini(5,17,(const unsigned char*)"Album",1);
				}
			if (Enigmes[4])
				{
				PrintMini(5,24,(const unsigned char*)"Lettre",1);
				}
			if (Enigmes[5])
				{
				PrintMini(5,31,(const unsigned char*)"Poste",1);
				}
			if (Enigmes[6])
				{
				PrintMini(5,38,(const unsigned char*)"Fiscal",1);
				}
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, ALPHA_LOCKED);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"TIMBRE")) 
				{
				BonneReponse();
				FinEnigme(eni,30);
				PrintMini(3,20,(const unsigned char*)"Qu'il y a-til dans ce batiment",1);
				PrintMini(3,27,(const unsigned char*)"pour qu'il soit si protege ?",1);
				ML_display_vram();
				NoShift();
				if (!Enigmes[7])
					{
					Enigmes[7]=1;
					Layton[3]++;
					Layton[4]+=30;
					Debloquage(-3);
					NoShift();
					Debloquage(-2);
					NoShift();
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}
			if (enigme==10)
			{
			ML_clear_vram();
			PrintMini(2,3,(const unsigned char*)"Bruno, David, Gregory et Thomas",1);
			PrintMini(2,9,(const unsigned char*)"sont sur les marches d'un es-",1);
			PrintMini(2,15,(const unsigned char*)"calier. Qui est Bruno, en sac-",1);
			PrintMini(2,21,(const unsigned char*)"hant que : Bruno et Thomas ne",1);
			PrintMini(2,27,(const unsigned char*)"sont pas a cote. Gregory et",1);
			PrintMini(2,33,(const unsigned char*)"David sont cote a cote. Thomas",1);
			PrintMini(2,39,(const unsigned char*)"est plus haut que Gregory.",1);
			ML_display_vram();
			NoShift();
			Shift();
			ML_clear_vram();
			ML_filled_circle(48,7, 6,1);
			ML_circle(56,15,6,1);
			ML_filled_circle(64,23,6,1);
			ML_circle(72,32,6,1);
			ML_line(40,14,50,14,1);
			ML_line(50,14,50,22,1);
			ML_line(50,22,58,22,1);
			ML_line(58,22,58,30,1);
			ML_line(58,30,66,30,1);
			ML_line(66,30,66,38,1);
			ML_line(66,38,40,38,1);
			ML_line(40,38,40,14,1);
			PrintXY(45,4,(const unsigned char*)"A",1);
			PrintXY(53,12,(const unsigned char*)"B",0);
			PrintXY(61,20,(const unsigned char*)"C",1);
			PrintXY(69,29,(const unsigned char*)"D",0);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_AZ,2,7, 35, LEFT, ALPHA_LOCKED);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"D")) 
				{
				BonneReponse();
				FinEnigme(eni,30);
				PrintMini(3,20,(const unsigned char*)"Quel bouchon, vivement qu'ils",1);
				PrintMini(3,27,(const unsigned char*)"aient les escalators !",1);
				ML_display_vram();
				if (!Enigmes[10])
					{
					Enigmes[10]=1;
					Layton[3]++;
					Layton[4]+=30;
					NoShift();
					Shift();
					Debloquage(enigme);
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}
		if (enigme==11)
			{
			ML_clear_vram();
			PrintMini(5,3,(const unsigned char*)"En rendant visite a mon frere",1);
			PrintMini(5,10,(const unsigned char*)"a l'hopital, j'ai fait 500m av-",1);
			PrintMini(5,17,(const unsigned char*)"ant de me rappeler de lui app-",1);
			PrintMini(5,24,(const unsigned char*)"orter des fleurs. Je suis donc",1);
			PrintMini(5,31,(const unsigned char*)"alle chez le fleuriste. Il est",1);
			PrintMini(5,38,(const unsigned char*)"sur une ligne droite entre ma",1);
			PrintMini(5,45,(const unsigned char*)"maison et l'hopital, a 800m de",1);
			PrintMini(5,52,(const unsigned char*)"ce dernier. Je suis rentre",1);
			ML_display_vram();
			NoShift();
			Shift();
			ML_clear_vram();
			PrintMini(5,3,(const unsigned char*)"chez moi apres la visite, quel-",1);
			PrintMini(5,10,(const unsigned char*)"le distance ai-je parcouru ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"2600")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"Quand on n'a pas de tete, on",1);
				PrintMini(3,27,(const unsigned char*)"a des jambes !",1);
				ML_display_vram();
				if (!Enigmes[11])
					{
					Enigmes[11]=1;
					Layton[3]++;
					Layton[4]+=40;
					NoShift();
					Shift();
					Debloquage(enigme);
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}

		if (enigme==12)
			{
			ML_clear_vram();
			PrintMini(1,1,(const unsigned char*)"X et Y font un aller-retour",1);
			PrintMini(1,7,(const unsigned char*)"sur la meme route. A l'aller,",1);
			PrintMini(1,13,(const unsigned char*)"X conduit 40 km, et Y fit le res-",1);
			PrintMini(1,19,(const unsigned char*)"te. Au retour, X prit le volant",1);
			PrintMini(1,25,(const unsigned char*)"en premier et Y fit les 50 der-",1);
			PrintMini(1,31,(const unsigned char*)"niers km. Combien de km de",1);
			PrintMini(1,37,(const unsigned char*)"plus qu'Y a conduit X ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"20")) 
				{
				BonneReponse();
				FinEnigme(eni,50);
				PrintMini(3,20,(const unsigned char*)"Ils ont des noms assez",1);
				PrintMini(3,27,(const unsigned char*)"bizarres !",1);
				ML_display_vram();
				if (!Enigmes[12])
					{
					Enigmes[12]=1;
					Layton[3]++;
					Layton[4]+=50;
					NoShift();
					Shift();
					Debloquage(enigme);
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}
		if (enigme==13)
			{
			ML_clear_vram();
			ML_line(64,1,24,41,1);
			ML_line(64,1,104,41,1);
			ML_line(24,41,104,41,1);
			ML_line(34,31,94,31,1);
			ML_line(44,21,84,21,1);
			ML_line(54,11,74,11,1);
			ML_line(34,31,44,41,1);
			ML_line(44,41,74,11,1);
			ML_line(44,21,64,41,1);
			ML_line(64,41,84,21,1);
			ML_line(54,11,84,41,1);
			ML_line(84,41,94,31,1);
			PrintMini(1,1,(const unsigned char*)"Combien il y",1);
			PrintMini(1,7,(const unsigned char*)"a-t-il de",1);
			PrintMini(1,13,(const unsigned char*)"triangles ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"27")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"Quelque chose ne tourne pas",1);
				PrintMini(3,27,(const unsigned char*)"rond !",1);
				ML_display_vram();
				if (!Enigmes[13])
					{
					Enigmes[13]=1;
					Layton[3]++;
					Layton[4]+=40;
					NoShift();
					Shift();
					Debloquage(enigme);
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}
		if (enigme==14)
			{
			ML_clear_vram();
			Enigme14();
			PrintMini(1,1,(const unsigned char*)"Combien il y",1);
			PrintMini(1,7,(const unsigned char*)"a-t-il de",1);
			PrintMini(1,13,(const unsigned char*)"triangles ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"35")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"Au moins ce pentagone n'a pas",1);
				PrintMini(3,27,(const unsigned char*)"recu d'avion pour le demolir !",1);
				ML_display_vram();
				if (!Enigmes[14])
					{
					Enigmes[14]=1;
					Layton[3]++;
					Layton[4]+=40;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}
		if (enigme==15)
			{
			ML_clear_vram();
			PrintMini(1,2,(const unsigned char*)"3 karts vont a des vitesses dif-",1);
			PrintMini(1,8,(const unsigned char*)"ferentes. En 1 min, le 1 fait 2",1);
			PrintMini(1,14,(const unsigned char*)"tours de circuit, le 2 en fait 3",1);
			PrintMini(1,20,(const unsigned char*)"et le 3 fait 4 tours. Au bout de",1);
			PrintMini(1,26,(const unsigned char*)"combien de min seront-ils a",1);
			PrintMini(1,32,(const unsigned char*)"nouveau en meme temps sur",1);
			PrintMini(1,38,(const unsigned char*)"la ligne de depart ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"1")) 
				{
				BonneReponse();
				FinEnigme(eni,20);
				PrintMini(3,20,(const unsigned char*)"Certains ont beau aller plus",1);
				PrintMini(3,27,(const unsigned char*)"vite, ils se retrouvent au me-",1);
				PrintMini(3,34,(const unsigned char*)"me endroit !",1);
				ML_display_vram();
				NoShift();
				if (!Enigmes[15])
					{
					Enigmes[15]=1;
					Layton[3]++;
					Layton[4]+=20;
					Debloquage(-2);
					NoShift();
					Debloquage(-1);
					NoShift();
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}
		
		if (enigme==16)
			{
			ML_clear_vram();
			PrintMini(1,2,(const unsigned char*)"Une ville a un taux de crimina-",1);
			PrintMini(1,8,(const unsigned char*)"lite eleve, et une enquete a",1);
			PrintMini(1,14,(const unsigned char*)"montre qu'un endroit avait un",1);
			PrintMini(1,20,(const unsigned char*)"nombre de deces superieur a la",1);
			PrintMini(1,26,(const unsigned char*)"moyenne. Lequel est-ce ? Parc,",1);
			PrintMini(1,32,(const unsigned char*)"Commissariat, Cimetiere, Ecole,",1);
			PrintMini(1,38,(const unsigned char*)"Hopital, Carrefour, Eglise",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, ALPHA_LOCKED);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"HOPITAL")||!strcmp(buffer,"Hopital")) 
				{
				BonneReponse();
				FinEnigme(eni,30);
				PrintMini(3,20,(const unsigned char*)"L'hopital est le lieu ou se re-",1);
				PrintMini(3,27,(const unsigned char*)"trouvent tous les mourants.",1);
				ML_display_vram();
				if (!Enigmes[16])
					{
					Enigmes[16]=1;
					Layton[3]++;
					Layton[4]+=30;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}

		if (enigme==17)
			{
			ML_clear_vram();
			PrintMini(1,2,(const unsigned char*)"Je commence la nuit, je finis",1);
			PrintMini(1,8,(const unsigned char*)"le matin, je suis dans l'etang,",1);
			PrintMini(1,14,(const unsigned char*)"je suis dans le jardin et je",1);
			PrintMini(1,20,(const unsigned char*)"passe 2 fois dans l'annee, qui",1);
			PrintMini(1,26,(const unsigned char*)"suis-je ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, ALPHA_LOCKED);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"N")||!strcmp(buffer,"LETTRE N")) 
				{
				BonneReponse();
				FinEnigme(eni,30);
				PrintMini(3,20,(const unsigned char*)"J'espere que vous n'avez pas la",1);
				PrintMini(3,27,(const unsigned char*)"N de ces enigmes !",1);
				ML_display_vram();
				if (!Enigmes[17])
					{
					Enigmes[17]=1;
					Layton[3]++;
					Layton[4]+=30;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
				ML_display_vram();
			}

		if (enigme==18)
			{
			ML_clear_vram();
			if ((!Enigmes[10])&&(!Enigmes[11])&&(!Enigmes[12])&&(!Enigmes[13]))
				{
				PrintMini(5,3,(const unsigned char*)"Aucun symbole debloque.",1);
				}
			else
				{
				Symbole4();
				}
			if (Enigmes[10])
				{
				Symbole1();
				}
			if (Enigmes[11])
				{
				Symbole2();
				}
			if (Enigmes[12])
				{
				Symbole3();
				}
			if (Enigmes[13])
				{
				Symbole5();
				}
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if (!EasyInputError)
				{
				return;
				}
			if(!strcmp(buffer,"4")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"Que cache cette porte ?",1);
				ML_display_vram();
				NoShift();
				if (!Enigmes[18])
					{
					Enigmes[18]=1;
					Layton[3]++;
					Layton[4]+=40;
					NoShift();
					Shift();
					Debloquage(enigme);
					NoShift();
					Debloquage(-2);
					NoShift();
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}
		
		if (enigme==19)
			{
			ML_clear_vram();
			Enigme19();
			PrintMini(1,5,(const unsigned char*)"Combien il",1);
			PrintMini(1,12,(const unsigned char*)"y a-t-il de",1);
			PrintMini(1,19,(const unsigned char*)"carres ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"204")) 
				{
				BonneReponse();
				FinEnigme(eni,50);
				PrintMini(3,20,(const unsigned char*)"Echecs et Maths !",1);
				ML_display_vram();
				if (!Enigmes[19])
					{
					Enigmes[19]=1;
					Layton[3]++;
					Layton[4]+=50;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}

		if (enigme==20)
			{
			ML_clear_vram();
			PrintMini(1,5,(const unsigned char*)"Elles blessent toutes, mais la",1);
			PrintMini(1,12,(const unsigned char*)"derniere tue. Qu'est-ce ? N'",1);
			PrintMini(1,19,(const unsigned char*)"ecrivez pas de determinant.",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, ALPHA_LOCKED);
			if(!strcmp(buffer,"HEURES")||!strcmp(buffer,"Heures")) 
				{
				BonneReponse();
				FinEnigme(eni,30);
				PrintMini(3,20,(const unsigned char*)"La derniere heure de cette",1);
				PrintMini(3,27,(const unsigned char*)"enigme a sonnee...",1);
				ML_display_vram();
				if (!Enigmes[20])
					{
					Enigmes[20]=1;
					Layton[3]++;
					Layton[4]+=30;
					Debloquage(-4);
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}

		if (enigme==21)
			{
			ML_clear_vram();
			PrintMini(1,1,(const unsigned char*)"Sur un autel, il y a marque :",1);
			PrintMini(1,7,(const unsigned char*)"Ne prenez pas le trident ou",1);
			PrintMini(1,13,(const unsigned char*)"prenez la couronne. Ne prenez",1);
			PrintMini(1,19,(const unsigned char*)"pas la couronne ou prenez le",1);
			PrintMini(1,25,(const unsigned char*)"sceptre. Prenez la couronne ou",1);
			PrintMini(1,31,(const unsigned char*)"ne prenez pas le sceptre. Un",1);
			PrintMini(1,37,(const unsigned char*)"seul est vrai, faut-il prendre",1);
			PrintMini(1,43,(const unsigned char*)"le trident et la couronne ?",1);
			ML_rectangle(5,52,122,64,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,8, 35, LEFT, ALPHA_LOCKED);
			if(!strcmp(buffer,"NON")|!strcmp(buffer,"Non")) 
				{
				BonneReponse();
				FinEnigme(eni,50);
				PrintMini(3,20,(const unsigned char*)"S'il fallait prendre la cour-",1);
				PrintMini(3,27,(const unsigned char*)"onne, les affirmations 1 et 3",1);
				PrintMini(3,34,(const unsigned char*)"seraient vraies, mais une",1);
				PrintMini(3,41,(const unsigned char*)"seule est vraie.",1);
				ML_display_vram();
				if (!Enigmes[21])
					{
					Enigmes[21]=1;
					Layton[3]++;
					Layton[4]+=50;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}

		if (enigme==22)
			{
			ML_clear_vram();
			PrintMini(1,5,(const unsigned char*)"3 poissons sont dans un seau.",1);
			PrintMini(1,12,(const unsigned char*)"L'un meurt. Combien en res-",1);
			PrintMini(1,19,(const unsigned char*)"te-il ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"3")) 
				{
				BonneReponse();
				FinEnigme(eni,20);
				PrintMini(3,20,(const unsigned char*)"Un poisson est mort, mais on",1);
				PrintMini(3,27,(const unsigned char*)"n'a jamais dit qu'il n'y etait",1);
				PrintMini(3,34,(const unsigned char*)"plus !",1);
				ML_display_vram();
				if (!Enigmes[22])
					{
					Enigmes[22]=1;
					Layton[3]++;
					Layton[4]+=20;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}
		if (enigme==23)
			{
			ML_clear_vram();
			PrintMini(1,3,(const unsigned char*)"Un homme et son fils ont a eux'",1);
			PrintMini(1,10,(const unsigned char*)"deux douze fois l'age du fils. L'",1);
			PrintMini(1,17,(const unsigned char*)"homme a 11 fois l'age de son",1);
			PrintMini(1,24,(const unsigned char*)"fils. Sachant que leur age est",1);
			PrintMini(1,31,(const unsigned char*)"le carre du double de l'age du",1);
			PrintMini(1,38,(const unsigned char*)"fils, quel age a l'homme ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"33")) 
				{
				BonneReponse();
				FinEnigme(eni,50);
				PrintMini(3,20,(const unsigned char*)"Il n'y avait pas 36 solutions !",1);
				ML_display_vram();
				if (!Enigmes[23])
					{
					Enigmes[23]=1;
					Layton[3]++;
					Layton[4]+=50;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}

		if (enigme==24)
			{
			ML_clear_vram();
			PrintMini(1,3,(const unsigned char*)"Combien d'",1);
			PrintMini(1,10,(const unsigned char*)"allumettes au",1);
			PrintMini(1,17,(const unsigned char*)"minimum faut",1);
			PrintMini(1,24,(const unsigned char*)"il deplacer",1);
			PrintMini(1,31,(const unsigned char*)"pour avoir un",1);
			PrintMini(1,38,(const unsigned char*)"carre ?",1);
			ML_line(60,23,88,23,1);
			ML_line(92,23,120,23,1);
			ML_line(90,2,90,21,1);
			ML_line(90,25,90,44,1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"1")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"4 est le carre",1);
				PrintMini(3,26,(const unsigned char*)"de 2 !",1);
				ML_line(60,41,88,41,1);
				//ML_line(92,41,120,41,1);
				ML_line(90,20,90,39,1);
				ML_line(90,43,90,62,1);
				ML_line(60,41,90,20,1);
				ML_display_vram();
				if (!Enigmes[24])
					{
					Enigmes[24]=1;
					Layton[3]++;
					Layton[4]+=40;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}

		if (enigme==25)
			{
			ML_clear_vram();
			PrintMini(1,3,(const unsigned char*)"Combien de gouttes d'eau peut-",1);
			PrintMini(1,10,(const unsigned char*)"on mettre dans un verre vide ? ",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"1")) 
				{
				BonneReponse();
				FinEnigme(eni,20);
				PrintMini(3,20,(const unsigned char*)"Apres une goutte, le verre n'",1);
				PrintMini(3,27,(const unsigned char*)"est plus vide !",1);
				ML_display_vram();
				if (!Enigmes[25])
					{
					Enigmes[25]=1;
					Layton[3]++;
					Layton[4]+=20;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}
		if (enigme==26)
			{
			ML_clear_vram();
			PrintMini(1,3,(const unsigned char*)"Un passant longe une salle des",1);
			PrintMini(1,10,(const unsigned char*)"fetes. Les convives sont en",1);
			PrintMini(1,17,(const unsigned char*)"train de trinquer. Le passant",1);
			PrintMini(1,24,(const unsigned char*)"entend distinctement 36",1);
			PrintMini(1,31,(const unsigned char*)"tintements de verres.",1);
			PrintMini(1,38,(const unsigned char*)"Combien y a-t-il d'invites ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"9")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"Il y a 9 invites !",1);
				PrintMini(3,26,(const unsigned char*)"Un invite trinquera avec 8",1);
				PrintMini(3,32,(const unsigned char*)"autres, mais le suivant ne",1);
				PrintMini(3,38,(const unsigned char*)"trinquera plus qu'avec 7",1);
				PrintMini(3,44,(const unsigned char*)"autres invites, etc. ",1);
				ML_display_vram();
				if (!Enigmes[26])
					{
					Enigmes[26]=1;
					Layton[3]++;
					Layton[4]+=40;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}
		if (enigme==27)
			{
			ML_clear_vram();
			PrintMini(1,3,(const unsigned char*)"Je commence par un E.",1);
			PrintMini(1,10,(const unsigned char*)"Je me termine par un E.",1);
			PrintMini(1,17,(const unsigned char*)"Je ne peux contenir qu'une",1);
			PrintMini(1,24,(const unsigned char*)"seule lettre et pourtant,",1);
			PrintMini(1,31,(const unsigned char*)"je ne suis pas la lettre E.",1);
			PrintMini(1,38,(const unsigned char*)"Que suis-je ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"ENVELOPPE")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"Eh oui, c'est une enveloppe !",1);
				ML_display_vram();
				if (!Enigmes[27])
					{
					Enigmes[27]=1;
					Layton[3]++;
					Layton[4]+=40;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}
		if (enigme==28)
			{
			ML_clear_vram();
			PrintMini(0,3,(const unsigned char*)"Un architecte florentin peut",1);
			PrintMini(0,10,(const unsigned char*)"batir une tour en 6 semaines.",1);
			PrintMini(0,17,(const unsigned char*)"Un architecte flamand peut",1);
			PrintMini(0,24,(const unsigned char*)"faire la meme en 3 semaines.",1);
			PrintMini(0,31,(const unsigned char*)"S'ils s'unissaient, en combien de",1);
			PrintMini(0,38,(const unsigned char*)"semaines la construiraient-ils ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"2")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"Il leur faudrait 2 semaines,",1);
				PrintMini(3,26,(const unsigned char*)"L'architecte florentin en",1);
				PrintMini(3,32,(const unsigned char*)"batissant un tiers, et son",1);
				PrintMini(3,38,(const unsigned char*)"homologue flamand,",1);
				PrintMini(3,44,(const unsigned char*)"deux tiers.",1);
				ML_display_vram();
				if (!Enigmes[28])
					{
					Enigmes[28]=1;
					Layton[3]++;
					Layton[4]+=40;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}
		if (enigme==29)
			{
			ML_clear_vram();
			PrintMini(0,3,(const unsigned char*)"Quasimodo, le sonneur de",1);
			PrintMini(0,10,(const unsigned char*)"cloches, met 3 secondes",1);
			PrintMini(0,17,(const unsigned char*)"pour sonner 4 heures.",1);
			PrintMini(0,31,(const unsigned char*)"Combien de secondes mettra-",1);
			PrintMini(0,38,(const unsigned char*)"t-il pour sonner midi ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"11")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"Pour sonner les douzes",1);
				PrintMini(3,26,(const unsigned char*)"coups de midi, il mettra",1);
				PrintMini(3,32,(const unsigned char*)"11 secondes, correspondant ",1);
				PrintMini(3,38,(const unsigned char*)"aux onze intervalles",1);
				PrintMini(3,44,(const unsigned char*)"separant les douze coups.",1);
				ML_display_vram();
				if (!Enigmes[29])
					{
					Enigmes[29]=1;
					Layton[3]++;
					Layton[4]+=40;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}
		if (enigme==30)
			{
			ML_clear_vram();
			PrintMini(1,3,(const unsigned char*)"Hier, j'ai achete au marche un",1);
			PrintMini(1,10,(const unsigned char*)"encrier et une plume pour 110",1);
			PrintMini(1,17,(const unsigned char*)"ecus. L'encrier m'en a coute",1);
			PrintMini(1,23,(const unsigned char*)"cent de plus que la plume.",1);
			PrintMini(1,38,(const unsigned char*)"Quel est le prix de la plume ?",1);
			ML_rectangle(5,45,122,57,1,1,0);
			ML_display_vram();
			NoShift();
			EasyInputError=EI_input_string(buffer, 199,ALLOW_ALL,2,7, 35, LEFT, NORMAL);
			if(!strcmp(buffer,"5")) 
				{
				BonneReponse();
				FinEnigme(eni,40);
				PrintMini(3,20,(const unsigned char*)"La plume m'a coute",1);
				PrintMini(3,26,(const unsigned char*)"5 ecus.",1);
				PrintMini(3,38,(const unsigned char*)"110 - 100 = 10",1);
				PrintMini(3,44,(const unsigned char*)"10 : 2 = 5",1);
				ML_display_vram();
				if (!Enigmes[30])
					{
					Enigmes[30]=1;
					Layton[3]++;
					Layton[4]+=40;
					}
				}
			else
				{
				MauvaiseReponse();
				return;
				}
			}
	ML_display_vram();
	NoShift();
	Shift();
	NoShift();
	ML_clear_vram();
	ML_clear_screen();
}
int MauvaiseReponse()
{
	ML_clear_vram();
	ML_clear_screen();
	ReponseFausse();
	ML_clear_vram();
	ML_clear_screen();
}
int BonneReponse()
{
	ML_clear_vram();
	ML_clear_screen();
	ReponseVraie();
	ML_clear_vram();
	ML_clear_screen();
}

int FinEnigme(unsigned char *eni,int picarats)
{
	unsigned char *pic;
	ML_clear_vram();
	ML_clear_screen();
	ML_line(1,1,1,63,1);
	ML_line(1,1,127,1,1);
	ML_line(127,1,127,63,1);
	ML_line(1,63,127,63,1);
	ML_line(3,3,125,3,1);
	ML_line(3,12,125,12,1);
	ML_line(125,12,125,2,1);
	ML_line(3,12,3,3,1);
	ML_line(1,14,127,14,1);
	PrintMini(6,6,(const unsigned char*)"Enigme",1);
	PrintMini(35,6,(unsigned char *)eni,1);
	sprintf(pic,(const unsigned char*)"%d",picarats);
	PrintMini(80,6,(unsigned char *)pic,1);
	PrintMini(90,6,(const unsigned char*)"Picarats",1);
	ML_display_vram();
}

int Debloquage(enigme)
{
if(enigme!=-10)
	{Shift();}
NoShift();
ML_rectangle(22,21,105,40,1,1,0);
ML_line(106,22,106,42,1);
ML_line(23,41,106,41,1);
if(enigme!=-2)
	{PrintMini(25,24,(const unsigned char*)"Vous avez debloque :",1);}
switch (enigme)
	{
	case -10:
		PrintMini(24,32,(const unsigned char*)"une nouvelle mission",1);
		break;
	case -4:
		PrintMini(25,32,(const unsigned char*)"la piste de karting",1);
		break;
	case -3:
		PrintMini(25,32,(const unsigned char*)"l'acces au QG",1);
		break;
	case -2:
		PrintMini(25,24,(const unsigned char*)"Vous avez termine :",1);
		PrintMini(25,32,(const unsigned char*)"une mission",1);
		break;
	case -1:
		PrintMini(24,32,(const unsigned char*)"une nouvelle mission",1);
		break;
	case 1:
		PrintMini(45,32,(const unsigned char*)"Carnet",1);
		break;
	case 2:
		PrintMini(48,32,(const unsigned char*)"Voix",1);
		break;
	case 3:
		PrintMini(47,32,(const unsigned char*)"Album",1);
		break;
	case 4:
		PrintMini(47,32,(const unsigned char*)"Lettre",1);
		break;
	case 5:
		PrintMini(47,32,(const unsigned char*)"Poste",1);
		break;
	case 6:
		PrintMini(47,32,(const unsigned char*)"Fiscal",1);
		break;
	case 10:
		PrintMini(25,32,(const unsigned char*)"Une partie du code !",1);
		break;
	case 11:
		PrintMini(25,32,(const unsigned char*)"Une partie du code !",1);
		break;
	case 12:
		PrintMini(25,32,(const unsigned char*)"Une partie du code !",1);
		break;
	case 13:
		PrintMini(25,32,(const unsigned char*)"Une partie du code !",1);
		break;
	case 18:
		PrintMini(25,32,(const unsigned char*)"La clef du coffre !",1);
		break;
	}
ML_display_vram();
	//Indices pour trouver le mot "Timbre" et le symbole
}










	
