#include "fxlib.h"
#include "filebios.h"

int writeFile();
int readFile();

int writeFile(unsigned char* name,unsigned char* extension,unsigned char* source,int taille)
{
FONTCHARACTER filename[20]={'\\','\\','f','l','s','0','\\'};
int a = 0;
int handle;
do
{
filename[7+a]=name[a];
a++;
}while(name[a] != 0 && a<7);
filename[7+a] = '.';
filename[8+a] = extension[0];
filename[9+a] = extension[1];
filename[10+a] = extension[2];
filename[11+a] = 0;

Bfile_DeleteFile(filename);
Bfile_CreateFile(filename,taille);
handle = Bfile_OpenFile(filename,_OPENMODE_WRITE);
if(handle>-1)
{
Bfile_WriteFile(handle,source,taille);
Bfile_CloseFile(handle);
return 1;
}
return 0;
}

int readFile(unsigned char* name,unsigned char* extension,unsigned char* reception)
{
int taille;
FONTCHARACTER filename[20]={'\\','\\','f','l','s','0','\\'};
int handle;
int a = 0;
do
{
filename[7+a]=name[a];
a++;
}while(name[a] != 0 && a<7);
filename[7+a] = '.';
filename[8+a] = extension[0];
filename[9+a] = extension[1];
filename[10+a] = extension[2];
filename[11+a] = 0;


handle = Bfile_OpenFile(filename,_OPENMODE_READ);

if(handle<0)return 0;
taille = Bfile_GetFileSize(handle);
if(handle>-1)
{
Bfile_ReadFile(handle,reception,taille,0);

Bfile_CloseFile(handle);
return 1;
}
return 0;
}
