#ifndef _EASYINPUT
#define _EASYINPUT

#include <fxlib.h>
#include "syscall.h"

#define ALLOW_az				1
#define ALLOW_AZ				2
#define ALLOW_09				4
#define ALLOW_SPACE				8
#define ALLOW_DOT				16
#define ALLOW_SPECIAL_CHARS 	32
#define ALLOW_ALL				255


enum
{
	NORMAL,
	ALPHA,
	ALPHA_LOCKED
};

enum
{
	LEFT,
	CENTER,
	RIGHT
};

int EI_input_string(char* string, int string_length, int chars_allowed, int column, int row, int input_box_length, int align, int start_mode);
int EI_str_length(char* str);

#endif